# Gameplay (EN / [RU](gameplay_ru.md))

[<< Back](README.md)

![](screenshot.png)

## Description of the game field

The game field consists of three plots: **random plot**, **custom plot**, and **custom plot source**.

The random plot is displayed in **blue** and occupies **three-quarters of the screen**.

The custom plot is displayed in **light green** and occupies **half of the screen**.

The custom plot source is displayed in **green** (not light green) and occupies **half of the screen**. The line of this plot is **two times thinner** than the lines of the other plots.

The distance between the random and custom plots is displayed in the background:

- if the distance is **within the soft limit**, the background is **green**;
- if the distance is **beyond the soft limit**, but **within the hard limit**, the background is **yellow**;
- if the distance is **beyond the hard limit**, the background is **red**.

The limits have the following values:

- **soft limit** — **one-third** of the maximum plot height;
- **hard limit** — **two-thirds** of the maximum plot height.

## Functioning of the game field

### Changing of the plots

All three plots display how signals change as a function of time (just like an oscilloscope). Thus, all plot points are moving to the left at a certain speed, and the new ones appear from the right side.

The points added to the random plot have a random offset from the last point on that plot.

The custom plot and the custom plot source can have two states: **active** and **inactive**.

The points added to the custom plot have the constant offset from the last point of that plot. The offset sign depends on the plot state:

- if **active**, the offset is **positive** (the plot is **increasing**);
- if **inactive**, the offset is **negative** (the plot is **decreasing**).

The points added to the custom plot source can have only the two values and also depend on the plot state:

- if **active**, the value is the specified **maximum**;
- if **inactive**, the value is the specified **minimum**.

### Meaning of the plots

The random plot displays some random analog signal.

The custom plot displays an analog signal (simplified) derived from the original signal (see below) by passing it through an [RC circuit](https://en.wikipedia.org/wiki/RC_circuit).

The custom plot source displays a digital signal generated by the user (the original signal).

## The game goal and statistics

The game goal is to replicate the shape of the random plot by the custom plot as close as possible.

The game collects the statistics by measuring the distance between these two plots — how much (in percent) of the game session duration it was:

- **within the soft limit** (**green**-colored statistics);
- **beyond the soft limit**, but **within the hard limit** (**yellow**-colored statistics);
- **beyond the hard limit** (**red**-colored statistics).

The results are compared sequentially: first the green-colored percent, then if they are equal, the yellow-colored percent. The higher percent is considered the best.

The limits are described above.
