# Геймплей ([EN](gameplay.md) / RU)

[<< Назад](README_ru.md)

![](screenshot.png)

## Описание игрового поля

Игровое поле состоит из трёх графиков: **случайный график**, **пользовательский график** и **источник пользовательского графика**.

Случайный график отображается **синим** цветом и занимает **три четверти экрана**.

Пользовательский график отображается **светло-зелёным** цветом и занимает **половину экрана**.

Источник пользовательского графика отображается **зелёным** цветом (не светлым) и занимает так же **половину экрана**. При этом его **толщина в два раза меньше**, чем толщина остальных графиков.

На фоне графиков отображается дистанция между случайным и пользовательским графиками:

- если дистанция **меньше мягкого лимита**, фон имеет **зелёный** цвет;
- если дистанция **больше мягкого**, но **меньше жесткого лимита**, то фон имеет **жёлтый** цвет;
- если дистанция **больше жёсткого лимита**, то фон имеет **красный** цвет.

Лимиты имеют следующие значения:

- **мягкий лимит** — **одна треть** от максимальной высоты графиков;
- **жёсткий лимит** — **две трети** от максимальной высоты графиков.

## Функционирование игрового поля

### Изменение графиков

Все три графика отображают изменение неких сигналов в зависимости от времени (так же, как это делает осциллограф). Т.о. все точки каждого графика сдвигаются влево с некоторой скоростью, а справа добавляются новые.

Точки, которые добавляются к случайному графику, имеют случайное смещение относительно последней точки этого графика.

Пользовательский график и источник пользовательского графика могут быть в двух состояниях: **активные** и **неактивные**.

Точки, которые добавляются к пользовательскому графику, имеют постоянное смещение относительно последней точки этого графика. Знак смещения зависит от состояния графика:

- если график **активный**, смещение **положительное** (график **возрастает**);
- если график **неактивный**, смещение **отрицательное** (график **убывает**).

Точки, которые добавляются к источнику пользовательского графика, могут иметь только два значения и так же зависят от состояния графика:

- если график **активный**, значение **максимальное**;
- если график **неактивный**, значение **минимальное**.

### Смысл графиков

Случайный график отображает некий случайный аналоговый сигнал.

Пользовательский график отображает аналоговый сигнал (упрощённый), получающийся из исходного сигнала (см. ниже) посредством его пропускания через [RC-цепь](https://ru.wikipedia.org/wiki/RC-цепь).

Источник пользовательского графика отображает цифровой сигнал, формируемый пользователем (исходный сигнал).

## Цель игры и статистика

Целью игры является максимально точное повторение формы случайного графика пользовательским.

Игра ведёт статистику, оценивая, сколько процентов от длительности игровой сессии дистанция между этими графиками была:

- **меньше мягкого лимита** (**зелёный** цвет статистики);
- **больше мягкого**, но **меньше жесткого лимита** (**жёлтый** цвет статистики);
- **больше жёсткого лимита** (**красный** цвет статистики).

Сравнение результатов ведётся последовательно: сначала по зелёному цвету и только в случае его равенства — по жёлтому. Более высокий результат считается лучшим.

Описание лимитов см. выше.
